import axios from "axios";

const webupload = function (funcs) {
    let { file, requestUrl, fileFormKey = 'file', fileds = {}, pickerfunc, uploadfunc, progressfunc } = funcs
    if (!file) {
        let fileupload = document.getElementById('uploadfile_el');
        if (!fileupload) {
            fileupload = document.createElement('input')
            fileupload.setAttribute('id', 'uploadfile_el');
            fileupload.setAttribute('type', 'file');
            fileupload.setAttribute("style", 'visibility:hidden');
            document.body.appendChild(fileupload);
        }
        fileupload.addEventListener('change', e => {
            let file = e.target.files[0];
            e.target.value = '';
            pickerfunc(file)
            webuploadAction(file, funcs)
        }, {
                once: true
            })
        fileupload.click();
    } else {
        webuploadAction(file, funcs)
    }

}


const webuploadAction = function (file, funcs) {
    let { requestUrl, fileFormKey = 'file', fileds = {}, uploadfunc, progressfunc } = funcs
    let fd = new FormData();
    fd.append(fileFormKey, file);
    for (let key in fileds) {
        fd.append(key, fileds[key])
    }
    axios.post(requestUrl, fd, {
        headers: {
            'Content-Type': 'multipart/form-data'
        },
        onUploadProgress: (p => {
            progressfunc(Math.floor(100 * (p.loaded / p.total)) + '%');
        })
    }).then(resp => {
        resp = resp.data;
        if (resp.status)
            uploadfunc(null, resp)
        else
            uploadfunc(resp)
    }).catch(err => {
        uploadfunc(err, null)
    })
}

const nativeupload = () => {

}

function readAsDataURL(file, callback) {
    if (!/image\/\w+/.test(file.type)) {
        callback("请确保文件为图像文件")
    }
    var reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = function (e) {
        callback(null, this.result)
    }
}

export { webupload, nativeupload, readAsDataURL, webuploadAction }